Educational Codeforces Round 135 (Rated for Div. 2)A-D

A. Colored Balls: Revisited

找一个最大的即可,那么输出最大的那个值的下标就好了。

#include<bits/stdc++.h>
using namespace std;
const int maxn =2e6+10;
const int mod = 1e9+7;
#define ll long long
#define ull unsigned long long
int num[maxn];


void solve(){
    int n;
    cin>>n;
    for(int i = 1;i<=n;i++){
        cin>>num[i];
    }
    cout<<max_element(num+1,num+n+1)-num<<endl;
}

int main() {
    ios::sync_with_stdio(false),cin.tie(0),cout.tie(0);
    int t = 1;
    cin>>t;
    while(t--){
        solve();
    }
}

B. Best Permutation

构造题,如果我们倒退一下,就会想到最终答案最大只能为n+n-1,那么为了获得这个答案,我们要保证前面的数为0,那么分两种情况构造,如果是偶数的话直接倒着来就行,如果是奇数的话前面用123把这个奇数变成偶数性质即可。

#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define ull unsigned long long
const int maxn = 1e6+10;

int num[maxn];
void solve(){
    int n;
    cin>>n;
    if(n%2==0){
        for(int i = n-2;i>=2;i--)
            cout<<i<<" ";
        cout<<1<<" "<<n-1<<" "<<n<<endl;
    }
    else{
        cout<<1<<" "<<2<<" "<<3<<" ";
        for(int i = n-2;i>=4;i--)
            cout<<i<<" ";
        cout<<n-1<<" "<<n<<endl;
    }
}

int main(){
    ios::sync_with_stdio(false),cin.tie(0),cout.tie(0);
    int t = 1;
    cin>>t;
    while(t--){
        solve();
    }
}

C. Digital Logarithm

直接贪心暴力就好了,我们把两组数分别赛到大根堆中,如果堆顶相等就可以彼此直接消去,如果有一边比较大,那么想直接消去是不可能的,就只能用操作把这个数变小,ans++。

#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define ull unsigned long long
const int maxn = 1e6+10;
ll ans = 0;
int change(int x) {
    return to_string(x).length();
}

void solve(){
    int n,x;
    cin>>n;
    priority_queue<int>a,b;
    for(int i = 1;i<=n;i++){
        cin>>x;
        a.push(x);
    }
    for(int i = 1;i<=n;i++){
        cin>>x;
        b.push(x);
    }
    ans = 0;
    while(!a.empty()&&!b.empty()){
        if(a.top()==b.top()){
            a.pop(),b.pop();
        }
        else if(a.top()>b.top()){
            a.push(change(a.top()));
            a.pop();
            ans++;
        }
        else{
            ans++;
            b.push(change(b.top()));
            b.pop();
        }
    }
    cout<<ans<<endl;
}

int main(){
    ios::sync_with_stdio(false),cin.tie(0),cout.tie(0);
    int t = 1;
    cin>>t;
    while(t--){
        solve();
    }
}

D. Letter Picking

两个做法吧。

第一个是可以观察出,Bob是不可能获胜的,Bob只可能争取平局。因为假设最小的字符不在两边,那么Alice会争取让最后的局面变成类似cab这样,无论Bob取哪边,Alice都可以获得a作为前缀。那么Bob会去想办法让最小的字符放在两边,但是没有用,因为如果最小的字符暴露在外面,那么Alice把目标定在除去两端外最小的那个即可。同样,如面对类似baac这样的局面,Alice只要让自己第二个字符最小即可。

总之,Bob必败,现在问题就转换成Bob能否争取平局即可。Bob想要平局其实很简单,根据博弈论的对称性原理,采取和Alice一样的操作即可。

但是这个地方有个思维误区(D我就wa这了),就是Bob采取对称性原理的时候,Alice可以想办法破坏这个对称性原理,而且因为Alice是先手,是可以做到这一点的。

换而言之,如果后手在争取对称性平局,先手是有机会去破坏这个对称性达到胜利的。

很明显,如果类似BBCAAC这样的局面,不能无脑考虑Alice如果拿了B就可以直接拿掉B,还要考虑如果Alice如果拿了C就无法平局,换而言之就是Alice的必胜态

如果Bob想平局,只有这么一种可能,就是Alice拿左边的时候,Bob拿右边可以对称性,Alice拿右边的时候Bob拿左边可以对称性,或者剩下的全是对子(例如BBAA这样的情况)

AC1:

#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define ull unsigned long long
const int maxn = 1e6+10;
ll ans = 0;

void solve(){
    string s;
    cin>>s;
    int i = 0;
    int j = s.size()-1;
    while(i<j){
        if(s[i]==s[j]){
            i++,j--;
        }
        else
            break;
    }
    while(i<j){
        if(s[i]==s[i+1])
            i+=2;
        else
            break;
    }

    if(i<j){
        cout<<"Alice"<<endl;
    }
    else
        cout<<"Draw"<<endl;
}

int main(){
    ios::sync_with_stdio(false),cin.tie(0),cout.tie(0);
    int t = 1;
    cin>>t;
    while(t--){
        solve();
    }
}

第二种做法看一下数据范围可以想到用二维dp去做,因为每轮可选择的只有首和尾,而且具备无后效性,用区间dp一下应该就好了

#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define ull unsigned long long
const int maxn = 1e6+10;
ll ans = 0;
int dp[2001][2001];  //1是Alice赢,2是平局,3是Bob
string s;
int check(int l,int r,int x,int y){
    if(dp[l][r]!=2)
        return dp[l][r];//如果前一个状态不是平局的话,处于必胜态的人必定仍然能维持必胜态
    if(s[x]==s[y])
        return 2;
    if(s[x]<s[y])
        return 1;
    return 3;
}

void solve(){
    cin>>s;
    int n = s.size();
    for(int len = 2;len<=n;len+=2){
        for(int l = 0;l<=n-len;l++){
            int r = l+len-1;
            if(len==2){
                if(s[l]==s[r])
                    dp[l][r] = 2;
                else
                    dp[l][r] = 1;
                continue;
            }
            dp[l][r] = min(max(check(l+2,r,l,l+1), check(l+1,r-1,l,r)),max(check(l,r-2,r,r-1),check(l+1,r-1,r,l)));
            /*cout<<l<<" "<<r<<" "<<dp[l][r]<<endl;
            if(l==0&&r==n-1){
                cout<<check(l+2,r,l,l+1)<<" "<<check(l+1,r-1,l,r)<<" "<<check(l,r-2,r,r-1)<<" "<<check(l+1,r-1,r,l)<<endl;
            }*/
        }
    }
    if(dp[0][n-1]==1)
        cout<<"Alice"<<endl;
    else if(dp[0][n-1]==2)
        cout<<"Draw"<<endl;
    else
        cout<<"Bob"<<endl;

}

int main(){
    ios::sync_with_stdio(false),cin.tie(0),cout.tie(0);
    int t = 1;
    cin>>t;
    while(t--){
        solve();
    }
}

  • 2
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
"educational codeforces round 103 (rated for div. 2)"是一个Codeforces平台上的教育性比赛,专为2级选手设计评级。以下是有关该比赛的回答。 "educational codeforces round 103 (rated for div. 2)"是一场Codeforces平台上的教育性比赛。Codeforces是一个为程序员提供竞赛和评级的在线平台。这场比赛是专为2级选手设计的,这意味着它适合那些在算法和数据结构方面已经积累了一定经验的选手参与。 与其他Codeforces比赛一样,这场比赛将由多个问题组成,选手需要根据给定的问题描述和测试用例,编写程序来解决这些问题。比赛的时限通常有两到三个小时,选手需要在规定的时间内提交他们的解答。他们的程序将在Codeforces的在线评测系统上运行,并根据程序的正确性和效率进行评分。 该比赛被称为"educational",意味着比赛的目的是教育性的,而不是针对专业的竞争性。这种教育性比赛为选手提供了一个学习和提高他们编程技能的机会。即使选手没有在比赛中获得很高的排名,他们也可以从其他选手的解决方案中学习,并通过参与讨论获得更多的知识。 参加"educational codeforces round 103 (rated for div. 2)"对于2级选手来说是很有意义的。他们可以通过解决难度适中的问题来测试和巩固他们的算法和编程技巧。另外,这种比赛对于提高解决问题能力,锻炼思维和提高团队合作能力也是非常有帮助的。 总的来说,"educational codeforces round 103 (rated for div. 2)"是一场为2级选手设计的教育性比赛,旨在提高他们的编程技能和算法能力。参与这样的比赛可以为选手提供学习和进步的机会,同时也促进了编程社区的交流与合作。

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值